/* tabdialog.h 
 *
 * Copyright (C) 2008  Eshwari C
 *
 * Licensed under the Academic Free License version 2.1
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *
 *
 */
while :
do
dialog --backtitle "System & Process Information " --title "Main"\
"Menu" --menu "Move using [UP] [DOWN], Press [Enter] to\
   Select, Cancel to Quit" 80 80 5\
	Memory/Information	"Memory Information "\
	Process/Information     "Process Information "\
	Heavy/Processes/Information	"Heavy Processes Information "\
	Swappiness/Value		"Current value of Swappiness "\
	Dirty/Background/Ratio          "Current value of Dirty Background Ratio "\
	Huge/Pages			"Current amount of Huge Pages "\
	Exit	"Exit " 2>/tmp/menuitem.$$
if [ $? -eq 1 ]
then clear; exit;
fi
menuitem=`cat /tmp/menuitem.$$`
opt=$?	
   case $menuitem in
  Memory/Information) dialog --backtitle "Memory Information" --msgbox "`cat /proc/meminfo`" 60 60;;
  Process/Information)
  while :
  do
 `top -b -n 1 > a.txt & `; sleep 1; dialog --backtitle "Process Information" --yes-label "Refresh" --no-label "Back to main menu" --yesno "`head -n 23 a.txt`" 80 80;
  if [ $? -eq 1 ] 
  then break;
  fi
  done;;
  Heavy/Processes/Information) 
  while :
  do
  dialog --backtitle "Heavy Processes Information" --yes-label "Refresh" --no-label "Back to main menu" --yesno "`ps -eo pcpu,pmem,pid,user,args | sort -k 1 -r | head -10`" 80 80;
  if [ $? -eq 1 ]
  then break;
  fi
  done;;
  Swappiness/Value) dialog --backtitle "Current value of Swappiness " --yes-label "Change Value" --no-label "Back to main menu" --yesno "`cat /proc/sys/vm/swappiness`" 60 60;
  if [ $? -eq 0 ]
  then dialog --backtitle "Set Values " --title "Menu"\ "Menu" --menu "Move using [UP] [DOWN], Press [Enter] to\
   Select, Cancel to Quit" 80 80 5\
   	Set70     "Set to 70 "\
	Set90	  "Set to 90 "\
	Return\to\main\menu	  "Return to main menu" 2>/tmp/menuitem.$$
if [ $? -eq 1 ]
then clear; exit;
fi
menuitem1=`cat /tmp/menuitem.$$`
opt1=$?
  case $menuitem1 in
  Set70) `sysctl -w vm.swappiness=70`; dialog --msgbox "Setting Value to 70 ... Done !!" 30 30;;
  Set90) `sysctl -w vm.swappiness=90`; dialog --msgbox "Setting Value to 90 ... Done !!" 30 30;;
  Return\to\main\menu) exit;
  esac;
  fi;;
  Dirty/Background/Ratio) dialog --backtitle "Current value of Dirty Background Ratio " --yes-label "Change Value" --no-label "Back to main menu" --yesno "`cat /proc/sys/vm/dirty_background_ratio`" 60 60;
  if [ $? -eq 0 ] 
  then dialog --backtitle "Set Values " --title "Menu"\ "Menu" --menu "Move using [UP] [DOWN], Press [Enter] to\
   Select, Cancel to Quit" 80 80 5\
        Set25     "Set to 25 "\
        Set50     "Set to 50 "\
        Return\to\main\menu       "Return to main menu" 2>/tmp/menuitem.$$
if [ $? -eq 1 ]
then clear; exit;
fi
  menuitem2=`cat /tmp/menuitem.$$`
  opt2=$?
  case $menuitem2 in
  Set25) `sysctl -w vm.dirty_background_ratio=25`; dialog --msgbox "Setting Value to 25 ... Done !!" 30 30;;
  Set50) `sysctl -w vm.dirty_background_ratio=50`; dialog --msgbox "Setting Value to 50 ... Done !!" 30 30;;
  Return\to\main\menu) exit;
  esac;
  fi;;

    Huge/Pages) dialog --backtitle "Current value of Huge Pages " --yes-label "Change Value" --no-label "Back to main menu" --yesno "`cat /proc/sys/vm/nr_hugepages`" 60 60;
  if [ $? -eq 0 ]
  then dialog --backtitle "Set Values " --title "Menu"\ "Menu" --menu "Move using [UP] [DOWN], Press [Enter] to\
   Select, Cancel to Quit" 80 80 5\
        Set32     "Set to 32 "\
        Setnormal  "Set to 0 "\
        Return\to\main\menu       "Return to main menu" 2>/tmp/menuitem.$$
if [ $? -eq 1 ]
then clear; exit;
fi
  menuitem3=`cat /tmp/menuitem.$$`
  opt3=$?
  case $menuitem3 in
  Set32) `sysctl -w vm.nr_hugepages=32`; dialog --msgbox "Setting Value to 512 ... Done !!" 30 30;;
  Setnormal) `sysctl -w vm.nr_hugepages=0`; dialog --msgbox "Setting Value to 0 ... Done !!" 30 30;;
  Return\to\main\menu) exit;
  esac;
  fi;;



  Exit) dialog --backtitle "Confirm Exit" --yesno "Do you really want to exit (Y/N) ?" 7 38; if [ $? -eq 0 ]
  then dialog --backtitle "Bye" --msgbox "Bye !!" 6 18; rm -f a.txt; clear; break;
  fi;;
esac

rm -f /tmp/menuitem.$$
killall -e top
done
