/*
 * Created by SharpDevelop.
 * User: DakshinaMurthy
 * Date: 4/14/2008
 * Time: 9:57 PM
 * 
 * kmp_modify.cs
 *
 * Copyright (C) 2008   DakshinaMurthy
 *
 * Licensed under the Academic Free License version 2.1
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *
 *
 */
using Gtk;
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;

namespace kpm_change
{
/// <summary>
/// Description of MainWindow.
/// </summary>
public class MainWindow : Window
{
	public static Entry view ;
	public MainWindow() : base("MainWindow")
	{
		SetDefaultSize(300,300);
		VBox vbox = new VBox(false,0);
		VBox vbox1 = new VBox(false,0);
		VBox vbox2 = new VBox(false,0);
		VBox vbox3 = new VBox(false,0);
		Add(vbox);
		vbox.PackStart(vbox1,false,true,0);
		vbox.PackStart(vbox3,false,true,0);
		vbox.PackStart(vbox2,false,true,0);
		HBox hbox = new HBox(false,0);
		//HBox hbox1 = new HBox(false,0);
		HBox hbox2 = new HBox(false,0);
		Label spacing = new Label("                     ");
		Label spacing1 = new Label("                     ");
		Label spacing2 = new Label("                     ");
		Label l1 = new Label("Enter the factor:");
		view = new Entry();
		Label l2 = new Label("Min Time Slice");
		TextView view1 = new TextView();
		view.SetSizeRequest(20,20);
		view1.SetSizeRequest(120,20);
		Button update = new Button("Update");
		Button cancel = new Button("Cancel");
		vbox1.PackStart(hbox,false,true,0);
		vbox2.PackStart(hbox2,false,true,0);
		//vbox3.PackStart(hbox1,false,true,0);
		hbox.PackStart(spacing1,false,false,0);
		hbox.PackStart(l1,false,false,0);
		hbox.PackStart(view,false,true,0);
		//hbox1.PackStart(spacing2,false,false,0);
		//hbox1.PackStart(l2,false,false,0);
		//hbox1.PackStart(view1,false,true,0);
		hbox2.PackStart(spacing,false,false,0);
		hbox2.PackStart(update,false,false,0);
		hbox2.PackStart(cancel,false,false,0);
		update.Clicked += new EventHandler(updateHandler);
		cancel.Clicked += new EventHandler(cancelEvent);
		DeleteEvent += new DeleteEventHandler(MainWindowDeleteEvent);
		ShowAll();
	}
	
	[STAThread]
	public static void Main(string[] arg)
	{
		Application.Init();
		new MainWindow();
		Application.Run();
	}
	void cancelEvent(object o, EventArgs args){
		Application.Quit();
	}
	void MainWindowDeleteEvent(object o, DeleteEventArgs args)
	{
		Application.Quit();
		args.RetVal = true;
	}
	public void updateHandler(object o, EventArgs args){
		double maxValue = Convert.ToDouble(MainWindow.view.Text);
		TextReader reader = new StreamReader(@"/usr/src/linux-2.6.22/kernel/sched.c");
		TextWriter writer = new StreamWriter("sched1.c");
		Regex reg = new Regex(@"#define DEF_TIMESLICE");
		string str="";
		int val =(int)(maxValue*100);
		string newstr = val.ToString();
		string repl=String.Concat("(",String.Concat(newstr,String.Concat("*","HZ / 1000)")));
		string fix = "(100 * HZ / 1000)";
		Console.WriteLine(repl);
		while ((str=reader.ReadLine())!=null){
			string nstr=str;
			if(nstr.Contains(fix)){
				nstr = nstr.Replace(fix,repl);
			}
			writer.WriteLine(nstr);
		}	
		writer.Close();
		reader.Close();
		FileInfo file = new FileInfo("sched1.c");
		if(File.Exists("/usr/src/linux-2.6.22/kernel/sched.c")){
			File.Delete("/usr/src/linux-2.6.22/kernel/sched.c");
		}
		//FileInfo file1 = new FileInfo("sched1.c");
		file.MoveTo("/usr/src/linux-2.6.22/kernel/sched.c");
	}
	
}
}
